% This function mxNiSkeleton does (multiple) user-detection followed by
% user tracking on a kinect-stream
%
% P = mxNiSkeleton(KinectHandles);
%
% inputs
%   KinectHandles : Array with pointers to kinect node objects generated by
%          mxNiCreateContext, such as main, image, IR, Depth and User node.
%   P : An array with size 225 x 7
%       The columes are
%        1 : UserID, 
%        2: Tracking-Confidence, 
%        3,4,5 : X,Y,Z in world-coordinates (mm)
%        6,7 : X,Y in image coordinates (pixels)
%       The rows are the following:
%        HEAD,NECK, LEFT SHOULDER, LEFT ELBOW, LEFT HAND,RIGHT SHOULDER
%        RIGHT ELBOW, RIGHT HAND, TORSO, LEFT HIP, LEFT KNEE, LEFT FOOT
%        RIGHT HIP, RIGHT KNEE, RIGHT FOOT
%       The first user data is P(1:15,:), for the second user the
%       data stored P(16:30,:), for the third P(31:45) ...
%
%
% See also mxNiCreateContext, mxNiUpdateContext, mxNiDepth, mxNiPhoto,
%		mxNiInfrared, mxNiDeleteContext
%
% Mex-Wrapper is written by D.Kroon University of Twente (February 2011)  